os.execute('del /F /Q *.tmp >nul 2>nul');
--os.execute('cls');

package.path = 
       ''
    .. '..\\luagui5\\?.lua;'
    .. '..\\blackshark\\?.lua;'
    .. '..\\blackshark\\modules\\?.lua;'
    .. '..\\LuaSerializer\\?.lua;'
    .. '..\\LuaSocket\\?.lua;'
    .. '.\\luagui5\\?.lua;'
    .. '.\\blackshark\\?.lua;'
    .. '.\\blackshark\\modules\\?.lua;'
    .. '.\\LuaSerializer\\?.lua;'
    .. '.\\LuaSocket\\?.lua;'

__DO_NOT_ERASE_DEBRIEF_LOG__ = true;

pressedKeys             = {}
keyPressCount           = 0;
keyboardProcessors      = {}
hookLog                 = {};    
START_PARAMS.command    = 'quit';
main_w                  = 1024
main_h                  = 768
defaultReturnScreen     = 'mainmenu'
tempMissionName         = 'tempMission.miz'
trackFileName           = 'LastMissionTrack.trk';
watchTrackFileName      = '_LastMissionTrack.trk';
mainPath                = './'


print('LOP: ', __LOP__);
    
    
    
function hookFcn(event, lineNumber)
    local functionFilter = {
        ['unpack'] = true,
        ['xpcall'] = true,
        ['member'] = true,
        ['type'] = true,
        ['time'] = true,
        ['date'] = true,
        ['remove'] = true,
        ['isVisible'] = true,
        ['setText'] = true,
        ['(for generator)'] = true,
    }
    local info = debug.getinfo(2);
    local fun = info.name or '';
    if string.find(info.short_src, 'me_traceback') then
        return;
    end;
    if functionFilter[fun] then
        return;
    end;
    local counter = 3;
    local tabString = '';
    local _info = {};
    while _info ~= nil do        
        tabString = tabString .. '  ';
        _info = debug.getinfo(counter);
        counter = counter + 1;
    end;
    print(tabString .. info.short_src .. ' in line ' .. info.currentline .. ' in func: ' .. fun)
    -- local str = tabString .. info.short_src .. ' in line ' .. info.currentline .. ' in func: ' .. fun;
    -- local hookRec = {
        -- info = tabString .. fun .. ' - ' .. info.short_src .. ' in line ' .. info.currentline,
        -- short_src = tabString .. info.short_src,
        -- currentline = info.currentline,
        -- fun = fun,
        -- time = os.clock(),
    -- };
    --table.insert(hookLog, hookRec);
    --table.insert(hookLog, str);
end; 
--debug.sethook ( hookFcn, 'c' );

traceback = require('me_traceback')
i18 = require('i18n')
lfs = require('lfs')  -- Lua File System

local old_sort = table.sort;
table.sort = function(tbl, fun)
    if (type(tbl[1]) == 'string') and (fun == nil) then
        old_sort(tbl, function(op1, op2) return Gui.Utf8ToANSI(op1) < Gui.Utf8ToANSI(op2); end)
    else
        old_sort(tbl, fun)
    end;
end;


lfs.chdir('./blackshark');
-- mainPath = lfs.currentdir() .. '/'  --     
-- mainPath = string.gsub(mainPath, '\\', '/')

simPath             = mainPath .. '../'--     
reliefPath          = mainPath .. 'data/map/relief/' --    
dialogsDir          = mainPath .. 'modules/dialogs/' --    
tempMissionPath     = mainPath .. '../Temp/Mission/' --      
tempCampaignPath    = mainPath .. '../Temp/Campaign/' --      
themesPath          = mainPath .. 'themes/'
fontsPath           = themesPath .. 'fonts/'
imagesPath          = themesPath .. 'main/images/'

imageSearchPath = {
    imagesPath .. 'COMMON/',
    imagesPath,
    imagesPath .. 'BKG/',
    };

SEARCHPATH = {};
    
if __LOP__ == true then
    table.insert(imageSearchPath, 1, imagesPath .. 'LOP/');
    table.insert(SEARCHPATH, 1, 'LOP/');
else
    table.insert(imageSearchPath, 1, imagesPath .. 'BS/');
    table.insert(SEARCHPATH, 1, 'BS/');
end;    

function getSearchPath()
    return SEARCHPATH
end;

FILENAMESCACHE = {};
function getFileName(filePath, getLocalizedName)
    getLocalizedName = getLocalizedName or false;
    if FILENAMESCACHE[filePath] ~= nil then
        return FILENAMESCACHE[filePath];
    else
        filePath = string.gsub(filePath, [[\]], '/');
        filePath = string.gsub(filePath, [[\\]], '/');
        filePath = string.gsub(filePath, '//', '/');
    
        local fileName = filePath;
        if string.find(filePath, '%/') then 
            local str = string.reverse(filePath);
            str = string.match(str, '.-%/');
            str = string.reverse(str);
            str = string.sub(str,2);
            fileName = str;
        end;
        local dirName = string.sub(filePath, 1, string.len(filePath) - string.len(fileName));
        -- if dirName == '' then 
            -- dirName = './'
        -- end;
        
        local searchPath = {'./'};
        for i, v in ipairs(SEARCHPATH) do
            table.insert(searchPath, v);
        end;
    
        for i, path in ipairs(searchPath) do
            local fName = dirName .. path .. fileName;
            if getLocalizedName then 
                print('# trying localized:', fName)
                name = i18.getLocalizedFileName(fName)
                if name then
                    print('# success:', name);
                    FILENAMESCACHE[filePath] = name;
                    return name;
                else
                    print('# failed:', name);
                end;                
            else
                print('# trying:', fName)
                local f = io.open(fName);
                if f ~= nil then            
                    print('# success:', fName);
                    io.close(f)
                    FILENAMESCACHE[filePath] = fName;
                    return fName;
                else
                    print('# failed:', fName);                
                end 
            end;
        end;
    end;
    print('Error: file not found', filePath)
    return filePath; -- debug
end;

i18.setLocale(mainPath .. "../l10n")
i18.gettext.add_package("input")
i18.gettext.add_package("payloads")

os.setlocale("C")


dofile('./themes/main/Theme.lua')

U = require('me_utilities')
---[[
local old_print = print;
print = function(...)
    if Gui == nil then 
        return old_print(...);
    end;
    local params = {};
    for i,v in ipairs({...}) do 
        table.insert(params, tostring(v))
    end
    old_print(unpack(params));
end;
--]]


MAX_TEXTURE_SIZE = 2048

me_db = require('me_db_api')
me_db.create() --     

Gui = require('gui5')

Gui.FindImageFile = function(fileName)
    --print('FindImageFile:', fileName);
    --local fileName = getFileName(fileName);
    local name = i18n.getLocalizedFileName(fileName)
    if nil == name then
        fileName = Theme.imagesPath .. '/' .. U.extractFileName(fileName);
        name = i18n.getLocalizedFileName(fileName)
        if nil == name then
            name = fileName
        end;
    end
    return name
end



--      
panel_options = require('me_options')
panel_options.loadOptions()
fullscreen = panel_options.vdata.graphics.fullScreen.__value__
main_w = panel_options.vdata.graphics.width.__value__
main_h = panel_options.vdata.graphics.height.__value__

local screen_w, screen_h = Gui.GetCurrentVideoMode()
if screen_w <= main_w or screen_h <= main_h then
    fullscreen = true
end

if fullscreen then 
    main_w = screen_w;
    main_h = screen_h;
end;

Gui.SetIcon(themesPath .. 'main/images/'..SEARCHPATH[1]..'/icon.bmp')

Gui.Create(main_w, main_h, fullscreen) --        !!!
-- start music
if __LOP__ == true then
    editorMusicDir = '../Sounds/EditorMusic/LOP/'
else
    editorMusicDir = '../Sounds/EditorMusic/BS/'
end
music = require('me_music')
music.init(editorMusicDir)
music.setMusicVolume(panel_options.vdata.sound.music.__value__)
music.setEffectsVolume(panel_options.vdata.sound.gui.__value__)


panel_options.create(0, 0, main_w,  main_h)
--panel_options.updateDevices(); 
panel_options.loadInputOptions()

--print("GUI initialized", main_w, main_h)
--   -
wait_screen = require('me_wait_screen')
wait_screen.create(0, 0, main_w, main_h)
wait_screen.show(true);


--   
mmw = require('MainMenu')
mmw.create(0, 0, main_w, main_h)


--  fullscreen    ,    Gui.Create()   
-- Gui.GetWindowSize(),      ( fullscreen   )
main_w, main_h = Gui.GetWindowSize()

--  

--  Roads   C++       .
--  ,        
--         .
--    Roads     LuaSim/Projects.
--      Roads  Calendar.
--  Roads    Calendar, Vector2  Edge.
--  Vector2  Edge    LuaGeometry/Projects. 

Roads = require('Roads')



--  edTerrain -      Black Shark.
--          
--   Land.lsa2     
--    .
--   edTerrain     
--  ,       Lua.
--       lua-edTerrain.dll.
--      Common.dll  Math.dll, 
--      .

Terrain = require('edTerrain')
Terrain.Create(simPath..'Bazar/Terrain/Surface/land.lsa2')


Gui.SetGCFramesCount(40)


MsgWindow = require('MsgWindow');
MapWindow = require('me_map_window')
menubar = require('me_menubar')
toolbar = require('me_toolbar')
statusbar = require('me_statusbar')
-- panel_airplane = require('me_airplane')
-- panel_helicopter = require('me_helicopter')
--panel_airplane = require('me_airplane')
--panel_helicopter = require('me_aircraft')
panel_aircraft = require('me_aircraft')
panel_ship = require('me_ship')
panel_vehicle = require('me_vehicle')
panel_summary = require('me_summary')
panel_targeting = require('me_targeting')
panel_route = require('me_route')
panel_loadout = require('me_loadout')
panel_payload = require('me_payload')
panel_fix_points = require('me_fix_points')
panel_static = require('me_static')
panel_coalitions = require('me_coalitions')
panel_weather = require('me_weather')
panel_map_options = require('me_map_options')
panel_mis_options = require('me_misoptions')
module_mission = require('me_mission')
panel_briefing = require('me_briefing')
panel_autobriefing = require('me_autobriefing');
panel_debriefing = require('me_debriefing')
panel_openfile = require('me_openfile')
panel_file_dialog = require('me_file_dialog')
panel_record_avi = require('record_avi')
panel_failures = require('me_failures')
panel_enc = require('me_encyclopedia')
panel_about = require('me_about')
panel_goal = require('me_goal')
panel_trigrules = require('me_trigrules')
panel_zone = require('me_trigger_zone')
panel_template = require('me_template')
panel_training = require('me_training')
panel_logbook = require('me_logbook')
panel_campaign = require('me_campaign')
panel_units_list = require('me_units_list')
panel_trig_zones_list = require('me_trig_zones_list')
panel_campaign_editor = require('me_campaign_editor');
options_assignment_panel = require('me_options_assignment');
options_axis_tune_panel = require('me_options_axis_tune');
NewInput = require('NewInput');
panel_campaign_end = require('me_campaignend');
exit_dialog = require('me_exit_dialog');
quickstart = require('me_quickstart');


--debriefing_utils = require('debriefing_utils')

local planner_mission = false


--     
top_toolbar_h = U.top_toolbar_h            
left_toolbar_w = U.left_toolbar_w           
bottom_toolbar_h = U.bottom_toolbar_h         
right_toolbar_w = U.right_toolbar_w 
map_w = main_w - left_toolbar_w        
local right_toolbar_h = U.right_toolbar_h 

--   ,    
--   updateWorld().
mapListCount = 0
loaded = 0

--    .
--    - .
--    ,       
--   .
--          
--  -. ,     ,
--       .  ,  
--         . 
--      .    
--           , 
--   .
function loading()
    --backupTrackMission();
    --   
    MapWindow.create(left_toolbar_w, top_toolbar_h, main_w - left_toolbar_w, main_h - top_toolbar_h - bottom_toolbar_h + 1)
    --        200tkrm.rsc.lua, 
    --    RSCparser.lua      
    --   200tkrm.rsc.txt.
  
    --           *.txf 
    --    SXFparser.lua    *.lua.
    --      lua.exe    *.luac 
    --    lists.zip,    
    --     .      
    --         .

    menubar.create( 0, 0, main_w, top_toolbar_h )
    toolbar.create( 0, top_toolbar_h, left_toolbar_w, main_h - top_toolbar_h - bottom_toolbar_h )
    panel_briefing.create(main_w - right_toolbar_w - 30, top_toolbar_h, right_toolbar_w + 30,  main_h - top_toolbar_h - bottom_toolbar_h)
    panel_autobriefing.create(0, 0, main_w, main_h);
    panel_debriefing.create(0, 0, main_w, main_h)
    panel_coalitions.create(main_w - 390, top_toolbar_h, 390, main_h - top_toolbar_h - bottom_toolbar_h)
    panel_openfile.create(main_w - 390, 0, 390, main_h)
    panel_file_dialog.create((main_w - 474)/2, (main_h - 474)/2, 390, main_h - top_toolbar_h - bottom_toolbar_h)
    panel_record_avi.create(main_w - right_toolbar_w, top_toolbar_h, right_toolbar_w,  main_h - top_toolbar_h - bottom_toolbar_h)
    panel_enc.create(0, 0,  main_w, main_h)
    panel_about.create(main_w - 390, top_toolbar_h, 390,  main_h - top_toolbar_h - bottom_toolbar_h) 
    panel_failures.create(main_w - 390, top_toolbar_h + right_toolbar_h, 390,  main_h - top_toolbar_h - bottom_toolbar_h - right_toolbar_h) 
    panel_weather.create(main_w - 390, top_toolbar_h, 390,  main_h - top_toolbar_h - bottom_toolbar_h) 

    
    panel_training.create(0, 0, main_w, main_h)
    panel_campaign_editor.create(0, 0, main_w, main_h)

    statusbar.create(0, main_h-bottom_toolbar_h + 1, main_w, bottom_toolbar_h - 1)
    panel_map_options.create(main_w - right_toolbar_w, top_toolbar_h, right_toolbar_w,  main_h - top_toolbar_h - bottom_toolbar_h) 
    panel_logbook.create(0, 0, main_w, main_h)
    panel_mis_options.create(0, top_toolbar_h, main_w, main_h - top_toolbar_h - bottom_toolbar_h) 
    panel_campaign.create(main_w - right_toolbar_w, top_toolbar_h, right_toolbar_w,  main_h - top_toolbar_h - bottom_toolbar_h)
    panel_summary.create(main_w - right_toolbar_w, top_toolbar_h + right_toolbar_h, right_toolbar_w,  main_h - top_toolbar_h - bottom_toolbar_h  - right_toolbar_h)
    panel_targeting.create(main_w - right_toolbar_w, top_toolbar_h + right_toolbar_h, right_toolbar_w,  main_h - top_toolbar_h - bottom_toolbar_h  - right_toolbar_h)
    panel_route.create(main_w - right_toolbar_w, top_toolbar_h + right_toolbar_h, right_toolbar_w,  main_h - top_toolbar_h - bottom_toolbar_h  - right_toolbar_h)
    panel_loadout.create(left_toolbar_w + 1, top_toolbar_h, main_w-left_toolbar_w-right_toolbar_w - 1,  main_h - top_toolbar_h - bottom_toolbar_h)
    panel_payload.create(main_w - right_toolbar_w, top_toolbar_h + right_toolbar_h, right_toolbar_w,  main_h - top_toolbar_h - bottom_toolbar_h  - right_toolbar_h)
    panel_fix_points.create(main_w - right_toolbar_w, top_toolbar_h + right_toolbar_h, right_toolbar_w,  main_h - top_toolbar_h - bottom_toolbar_h  - right_toolbar_h)
    --panel_airplane.create(main_w - right_toolbar_w, top_toolbar_h, right_toolbar_w, right_toolbar_h)
    panel_aircraft.create(main_w - right_toolbar_w, top_toolbar_h, right_toolbar_w, right_toolbar_h)
    panel_ship.create(main_w - right_toolbar_w, top_toolbar_h, right_toolbar_w, right_toolbar_h)
    panel_vehicle.create(main_w - right_toolbar_w, top_toolbar_h, right_toolbar_w, right_toolbar_h)
    panel_static.create(main_w - right_toolbar_w, top_toolbar_h, right_toolbar_w, main_h - top_toolbar_h - bottom_toolbar_h)
    panel_goal.create(0, top_toolbar_h, main_w,  main_h - top_toolbar_h - bottom_toolbar_h) 
    panel_trigrules.create(0, top_toolbar_h, main_w,  main_h - top_toolbar_h - bottom_toolbar_h) 
    panel_zone.create(main_w - right_toolbar_w, top_toolbar_h, right_toolbar_w,  main_h - top_toolbar_h - bottom_toolbar_h) 
    panel_template.create(main_w - right_toolbar_w, top_toolbar_h, right_toolbar_w,  main_h - top_toolbar_h - bottom_toolbar_h) 
    panel_units_list.create(left_toolbar_w, main_h - bottom_toolbar_h - 300, main_w - right_toolbar_w - left_toolbar_w,  300);
    panel_trig_zones_list.create(left_toolbar_w, main_h - bottom_toolbar_h - 300, main_w - right_toolbar_w - left_toolbar_w,  300);
    panel_campaign_end.create(0, 0, main_w, main_h);
    exit_dialog.create(main_w, main_h);
    quickstart.create(main_w, main_h);
    
    module_mission.create()
    --U.traverseTable(START_PARAMS);
    
    function trimQuotes(str)
        if string.find(str, '^"') and string.find(str, '"$') then
            local res = string.sub(str, 2, -2);
            return res;
        else
            return str;
        end        
    end;
    
    local realMissionName;
    START_PARAMS.missionPath = trimQuotes(START_PARAMS.missionPath);
    if START_PARAMS.missionPath and ('' ~= START_PARAMS.missionPath) then
        if U.startsWith(START_PARAMS.missionPath, 'BlackShark/./') then
            START_PARAMS.missionPath = string.sub(START_PARAMS.missionPath, 12)
        end
        realMissionName = START_PARAMS.realMissionPath;
        --print('realMissionName',realMissionName);
        realMissionName = trimQuotes(realMissionName or '');
        --print('realMissionName',realMissionName);
        if U.startsWith(realMissionName, 'BlackShark/./') then
            realMissionName = string.sub(realMissionName, 12)
        end
        module_mission.load(START_PARAMS.missionPath, true); --    ,        
        --module_mission.load(realMissionName, true);
        module_mission.mission.path = realMissionName;
        statusbar.t_file:setText(U.extractFileName(realMissionName));
    else
        local path = mainPath .. '../Temp/' .. tempMissionName;
        print('removing',path);
        os.remove(path);
        module_mission.clearTempFolder();
    end;
    
    if '' == START_PARAMS.returnScreen then 
        mmw.show(true);
    elseif START_PARAMS.returnScreen == 'training' then
        module_mission.create_new_mission();
        panel_training.show(true, realMissionName);
    elseif 'prepare' == START_PARAMS.returnScreen  then
        if realMissionName == nil then
            print('realMissionName == nil');
            return;
        end;
        module_mission.copyMission(realMissionName, START_PARAMS.missionPath);
        module_mission.load(realMissionName, true);
        MapWindow.show(true)
        menubar.show(true)
        toolbar.show(true)
        statusbar.show(true)
    else
        panel_debriefing.returnScreen = START_PARAMS.returnScreen;
        panel_debriefing.show(true)
    end;
    collectgarbage('collect')
    wait_screen.show(false)
    os.setlocale("C")
end

-------------------------------------------------------------------------------
function setPlannerMission(pm)
	planner_mission = pm
end

-------------------------------------------------------------------------------
function isPlannerMission()
	return planner_mission
end

function setInputProcessor(_inputProcessor)    
    --panel_options.resetSelection()
    --print('_inputProcessor',_inputProcessor);
    inputProcessor = _inputProcessor;
end; 

function getInputProcessor()    
    return inputProcessor;
end; 


--         GUI.          
function Gui.Update()
    if inputProcessor ~= nil then
        inputProcessor();
    end;
  --   


    realTime = os.time()
    if realTimePrev then
      if realTime - realTimePrev >= 1 then

       if statusbar.form and statusbar.form.window then
      --   .
      --     ,   
          realTimePrev = realTime
          if statusbar.form.window:isVisible() then
            local date = os.date('*t');
            local str = string.format('%02d.%02d.%02d %02d:%02d:%0d', date.day, date.month, date.year-2000, date.hour, date.min, date.sec)
            
            statusbar.form.t_clock:setText(str)
          end
       end
     end
    else
      realTimePrev = realTime
    end
end

function restartME()
    START_PARAMS.command = '';
    START_PARAMS.missionPath = '';
    START_PARAMS.returnScreen = '';
    RETURN_SCREEN = '';
    MISSION_PATH = '';
    lfs.chdir('..');
    Gui.Quit();    
end; 

--    GUI.
--     -   Gui.stop().
--        .
function Gui.KeyboardCallback(key, keyState)
    if keyState == 'down' then
        pressedKeys[key] = true;
        local str = '';
        for k,v in pairs(pressedKeys) do
            if v then
                if str == '' then 
                    str = k;
                else
                    str = str .. ' + ' .. k;
                end;
            end;
        end;
        --print('key = ',str);
    elseif keyState == 'up' then
        pressedKeys[key] = nil;
    end;
   --[[ if pressedKeys['left ctrl'] and pressedKeys['l'] and (not pressedKeys['left shift'])then
        print('turning log ON');
        turnLog(true);
        return;
    elseif pressedKeys['left ctrl'] and pressedKeys['l'] and pressedKeys['left shift'] then
        print('turning log OFF');    
        turnLog(false);
        return;
    else]]
        for window, keyProcessor in pairs(keyboardProcessors) do
            if panel_options.form.containerControls 
                and panel_options.form.containerControls:isVisible()  then
                return;
            end;
            local skip = false;
            if window:isVisible() and window:isEnabled() then
                --print('window', window)
                getChildren = function(_widget)
                    local widgets = _widget:getWidgets();
                    for i,widget in ipairs(widgets) do 
                        if widget.getWidgets ~= nil then
                            if getChildren(widget) then
                                return true;
                            end;
                        end
                        if widget:isVisible() then
                            --print('    widget', widget:getText(), widget.receivesKeyboardInput, widget:getFocus())
                            if widget.receivesKeyboardInput and widget:getFocus()  then
                                --print('skipping')
                                return true;
                            end;
                        end;
                    end
                    return false;
                end; 
                if getChildren(window) then
                    skip = true;
                end;
            end;
            if skip then 
                return;
            end;
        end;
        for window, keyProcessor in pairs(keyboardProcessors) do
            if panel_options.form.containerControls 
                and panel_options.form.containerControls:isVisible()  then
                return;
            end;
            if window:isVisible() and window:isEnabled() then
                keyProcessor(window, pressedKeys)
            end;
        end;
   -- end;
end;  


function writeLog()
    turnLog(false);
    if #hookLog >0 then
        local date = os.date();
        date = string.gsub(date, '[/:]','-');
        local logName = './temp/Blackshark-' .. date ..'.log';
        print('saving log', logName);
        local f, err = io.open(logName, 'w');
        if f == nil then
            print(err)
        end;
        --f:write('local log = {\n');
        for i, rec in ipairs(hookLog) do
            -- f:write(string.format("{ src = %s, line = %d, fun = %s, time = %f },\n", 
                -- rec.short_src,
                -- rec.currentline,
                -- rec.fun,
                -- rec.time));
            f:write(rec..'\n'); 
        end;
        --f:write('}\n');
        f:close();
    end;    
end; 

function turnLog(b)
    if b then
        debug.sethook ( hookFcn, 'c' );
        --profiler.start();
    else
        debug.sethook ( );
        --profiler.stop();
    end;
end;

function Gui.onQuit()
    exit_dialog.show(true);
end; 


function backupTrackMission()
    local dir = '..\\temp\\history';
    if not lfs.dir(dir)() then
        print('creating history dir '..dir)
        local res, err = lfs.mkdir(dir);
        print('lfs: ',res, err);
    end;

    -- local mission = io.open(Gui.Utf8ToANSI(mainPath .. '/temp/' .. tempMissionName), 'rb')
    -- if mission == nil then
        -- return;
    -- end;
    local timeTbl = os.date('*t');
    local timeStr = tostring(timeTbl.month) .. '-' .. tostring(timeTbl.day) ..
        '-' .. tostring(timeTbl.hour) .. '-' .. tostring(timeTbl.min) .. 
        '-' .. tostring(timeTbl.sec);

    local source = '..\\temp\\' .. tempMissionName;
    local dest = dir .. '\\tempMission_' .. timeStr .. '.miz';
    local str = string.format('copy %s %s >> nul', source, dest);
    --print(str);
    os.execute(str);
    
    local source = '..\\temp\\' .. trackFileName;
    local dest = dir .. '\\LastMissionTrack_' .. timeStr .. '.trk';
    local str = string.format('copy %s %s >> nul', source, dest);
    --print(str);
    os.execute(str);
    --mission:close()

    local source = '..\\temp\\debrief.log';
    local dest = dir .. '\\debrief_' .. timeStr .. '.log';
    local str = string.format('copy %s %s >> nul', source, dest);
    --print(str);
    os.execute(str);
    
    -- local data  = mission:read('*a')    
    -- if data == nil then
        -- return;
    -- end;
    
    -- local dest = dir .. tempMissionName;
    -- local file = io.open(Gui.Utf8ToANSI(dest), 'wb')
    -- if file then        
        -- file:write(data)
        -- file:close();
    -- end

end; 

function seed()
    local int, fr = math.modf(os.clock());
    fr = math.floor(fr*10000);
    math.randomseed(fr)    
end;

seed();

loading()

Gui.Run()

writeLog()

--os.remove(mainPath .. '../Temp/' .. tempMissionName);
